SystemOrganization addCategory: #PacMan!

TestCase subclass: #PacManTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!PacManTest methodsFor: 'actors' stamp: 'HernanWilkinson 4/29/2013 20:40'!
blueGhost

	^Ghost blue! !

!PacManTest methodsFor: 'actors' stamp: 'HernanWilkinson 4/29/2013 21:04'!
blueberry

	^Fruit new! !

!PacManTest methodsFor: 'movements' stamp: 'HernanWilkinson 4/29/2013 21:00'!
down

	^ 0 @ -1! !

!PacManTest methodsFor: 'construction block types' stamp: 'HernanWilkinson 4/29/2013 21:02'!
ghostHouseDoorType

	^GhostHouseDoorType new! !

!PacManTest methodsFor: 'movements' stamp: 'HernanWilkinson 4/29/2013 20:58'!
left

	^ -1@0! !

!PacManTest methodsFor: 'construction block types' stamp: 'EmilianoMenendezEzequielNicols 4/29/2013 21:35'!
leftTransporterType

	^ LeftTransporterType new! !

!PacManTest methodsFor: 'actors' stamp: 'HernanWilkinson 4/29/2013 21:01'!
pacman

	^Pacman new! !

!PacManTest methodsFor: 'movements' stamp: 'HernanWilkinson 4/29/2013 21:00'!
right

	^1@0! !

!PacManTest methodsFor: 'construction block types' stamp: 'HernanWilkinson 4/29/2013 21:01'!
spaceType

	^SpaceType new
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:31'!
test01GhostCanNotGoIntoAWall

	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self left ).
	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self right ).
	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self up ).
	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:31'!
test02PacmanCanNotGoIntoAWall

	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self left ).
	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self right ).
	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self up ).
	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:38'!
test02aFruitCanNotGoIntoAWall

	self assert: self blueberry position equals: ( self wallType nextPositionFor: self blueberry going: self left ).
	self assert: self blueberry position equals: ( self wallType nextPositionFor: self blueberry going: self right ).
	self assert: self blueberry position equals: ( self wallType nextPositionFor: self blueberry going: self up ).
	self assert: self blueberry position equals: ( self wallType nextPositionFor: self blueberry going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:31'!
test03GhostMovesIntoSpaces

	self assert: ( self blueGhost position + (-1@0) ) equals: ( self spaceType nextPositionFor: self blueGhost going: self left ).
	self assert: ( self blueGhost position +  (1@0) ) equals: ( self spaceType nextPositionFor: self blueGhost going: self right ).
	self assert: ( self blueGhost position +  (0@1) ) equals: ( self spaceType nextPositionFor: self blueGhost going: self up ).
	self assert: ( self blueGhost position + (0@ -1) ) equals: ( self spaceType nextPositionFor: self blueGhost going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:31'!
test04PacmanMovesIntoSpaces

	self assert: ( self pacman position + (-1@0) ) equals: ( self spaceType nextPositionFor: self pacman going: self left ).
	self assert: ( self pacman position +  (1@0) ) equals: ( self spaceType nextPositionFor: self pacman going: self right ).
	self assert: ( self pacman position +  (0@1) ) equals: ( self spaceType nextPositionFor: self pacman going: self up ).
	self assert: ( self pacman position + (0@ -1) ) equals: ( self spaceType nextPositionFor: self pacman going: self down ).

! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:39'!
test04aFruitMovesIntoSpaces

	self assert: ( self blueberry position + (-1@0) ) equals: ( self spaceType nextPositionFor: self blueberry going: self left ).
	self assert: ( self blueberry position +  (1@0) ) equals: ( self spaceType nextPositionFor: self blueberry going: self right ).
	self assert: ( self blueberry position +  (0@1) ) equals: ( self spaceType nextPositionFor: self blueberry going: self up ).
	self assert: ( self blueberry position + (0@ -1) ) equals: ( self spaceType nextPositionFor: self blueberry going: self down ).

! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test05GhostCanEnterHisHouse

	self assert: ( self blueGhost position + (-1@0) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self left).
	self assert: ( self blueGhost position +  (1@0) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self right ).
	self assert: ( self blueGhost position +  (0@1) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self up ).
	self assert: ( self blueGhost position + (0@ -1) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test06PacmanCanNotEnterGhostHouse

	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self left ).
	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self right ).
	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self up ).
	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:40'!
test06aFruitCanEnterHisHouse

	self assert: ( self blueberry position + (-1@0) ) equals: (self ghostHouseDoorType nextPositionFor: self blueberry going: self left).
	self assert: ( self blueberry position +  (1@0) ) equals: (self ghostHouseDoorType nextPositionFor: self blueberry going: self right ).
	self assert: ( self blueberry position +  (0@1) ) equals: (self ghostHouseDoorType nextPositionFor: self blueberry going: self up ).
	self assert: ( self blueberry position + (0@ -1) ) equals: (self ghostHouseDoorType nextPositionFor: self blueberry going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test07GhostCanNotGoIntoTransporter

	self assert: self blueGhost position equals: ( self leftTransporterType nextPositionFor: self blueGhost going: self left ).
	self assert: self blueGhost position equals: ( self leftTransporterType nextPositionFor: self blueGhost going: self right ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test08TransporterMovesPacmanToNewPosition

	self assert: (3@10) equals: ( self leftTransporterType nextPositionFor: self pacman going: self left ).
	self assert: (3@10) equals: ( self leftTransporterType nextPositionFor: self pacman going: self right ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:46'!
test09TransporterMovesFruitToNewPosition

	self assert: (5@10) equals: ( self leftTransporterType nextPositionFor: self blueberry going: self left ).
	self assert: (5@10) equals: ( self leftTransporterType nextPositionFor: self blueberry going: self right ).
! !

!PacManTest methodsFor: 'movements' stamp: 'HernanWilkinson 4/29/2013 21:00'!
up

	^0@1! !

!PacManTest methodsFor: 'construction block types' stamp: 'HernanWilkinson 4/29/2013 20:43'!
wallType

	^WallType new! !

Object subclass: #Fruit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Fruit methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielNicols 4/30/2013 20:19'!
nextPositionWhenMovingInto: aConstructionBlockType going: aDirection 
	
		^ aConstructionBlockType nextPositionForFruit: self going: aDirection! !

!Fruit methodsFor: 'as yet unclassified' stamp: 'HernanWilkinson 4/29/2013 21:04'!
position
	^0@0! !

Object subclass: #Ghost
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Ghost class methodsFor: 'as yet unclassified' stamp: 'HernanWilkinson 4/29/2013 20:40'!
blue
	
	^self new! !

!Ghost methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielNicols 4/30/2013 20:16'!
nextPositionWhenMovingInto: aConstructionBlockType going: aDirection 
		
	^aConstructionBlockType nextPositionForGhost: self going: aDirection .! !

!Ghost methodsFor: 'as yet unclassified' stamp: 'HernanWilkinson 4/29/2013 20:42'!
position
	
	^ 0 @ 0! !

Object subclass: #GhostHouseDoorType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!GhostHouseDoorType methodsFor: 'as yet unclassified' stamp: 'HernanWilkinson 4/29/2013 21:09'!
nextPositionFor: anActor  going: aDirection 

	^anActor nextPositionWhenMovingInto: self going: aDirection.
! !

!GhostHouseDoorType methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielNicols 4/30/2013 20:15'!
nextPositionForFruit: aFruit going: aDirection
	^aFruit position + aDirection! !

!GhostHouseDoorType methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielNicols 4/30/2013 20:09'!
nextPositionForGhost: aGhost going: aDirection
 ^aGhost position + aDirection! !

!GhostHouseDoorType methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielNicols 4/30/2013 20:13'!
nextPositionForPacman: aPacman going: aDirection
	^aPacman position ! !

Object subclass: #LeftTransporterType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!LeftTransporterType methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielNicols 4/30/2013 19:48'!
nextPositionFor: anActor going: aDirection 
	^anActor nextPositionWhenMovingInto:  self going: aDirection ! !

!LeftTransporterType methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielNicols 4/30/2013 20:20'!
nextPositionForFruit: aFruit going: aDirection
	^5@10! !

!LeftTransporterType methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielNicols 4/30/2013 20:17'!
nextPositionForGhost: aGhost going: aDirection
	^aGhost position! !

!LeftTransporterType methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielNicols 4/30/2013 20:18'!
nextPositionForPacman: aPacman going: aDirection
	^3@10! !

Object subclass: #Pacman
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Pacman methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielNicols 4/30/2013 20:17'!
nextPositionWhenMovingInto: aConstructionBlockType going: aDirection 
	
		
		^aConstructionBlockType nextPositionForPacman: self going: aDirection ! !

!Pacman methodsFor: 'as yet unclassified' stamp: 'HernanWilkinson 4/29/2013 21:01'!
position
	
	^ 0@ 0! !

Object subclass: #SpaceType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!SpaceType methodsFor: 'as yet unclassified' stamp: 'HernanWilkinson 4/29/2013 21:02'!
nextPositionFor: anActor  going: aDirection

	^anActor position + aDirection ! !

Object subclass: #WallType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!WallType methodsFor: 'as yet unclassified' stamp: 'HernanWilkinson 4/29/2013 21:00'!
nextPositionFor: anActor going: aDirection

	^anActor position
	
	! !
